



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[C++]内存字节对齐</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[C++]内存字节对齐</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 06:11:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>当我们写一个class类，然后sizeof(),然后发现这个值往往比你想象的大，这是为什么呢？这里就要讲到内存对齐的问题。</p>
<p>先来看一下内存对齐的几条原则：</p>
<p>1.对于class（struct/union)的各个成员，第一个数据成员放在偏移为0的地方，以后每个数据成员存储的其实位置要从该成员大小或者成员的子成员大小（只要该成员有子成员，比如说是数组，结构体等）的整数倍开始；</p>
<p>2.结构体作为成员时，结构体成员要从其内部最大元素大小的整数倍地址开始存储；</p>
<p>3.结构体的总大小，也就是sizeof的结果，必须是其内部最大成员的整数倍，不足要补齐。</p>
<p>下面看一个小例子：</p>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;<br />
using namespace std;

class student<br />
{<br />
private:<br />
    int number;//0-3<br />
    double weight;//8-15<br />
    char name[];//16-25<br />
    char sex[];//26-29<br />
};//补齐29-32

class student s;<br />
class teacher<br />
{<br />
private:<br />
    int number;//0-3<br />
    char name[];//4-13<br />
    char sex[];//14-17<br />
public:<br />
    student s[];//24-88<br />
};

int main()<br />
{<br />
    student s;<br />
    teacher t;<br />
    cout&lt;&lt;"student："&lt;&lt;sizeof(s)&lt;&lt;endl;<br />
    cout&lt;&lt;"teacher："&lt;&lt;sizeof(t)&lt;&lt;endl;<br />
    return ;<br />
}</pre>
</div>
<p>（补充讲一下，&ldquo;student s[2]&rdquo;是从24开始的，因为s的子成员weight的大小是8，所以从它的整数倍，也就是24开始。）</p>
<p>结果是：<br />student： 24</p>
<p>teacher： 88</p>
<p>下面就来解释一些疑问：</p>
<p><strong>1.什么是对齐？</strong></p>
<p>现代计算机中内存空间都是按照byte划分的，从理论上讲对任何类型的变量的访问可以从任何地址开始，但实际情况是在访问特定类型变量的时候经常在特定的内存地址访问，这就需要各种类型数据按照一定的规则在空间上排列，而不是顺序的一个接一个的排放，这就是对齐。</p>
<p><strong>2.为什么要对齐呢？</strong></p>
<p>硬件限制：不是所有的硬件平台都能访问任意地址上的数据；某些硬件平台只能在某些地址取特定类型的数据，否则抛出硬件异常。</p>
<p>提高性能：内存对齐后，CPU的内存访问速度大大提升。</p>
<p><strong>3.那些情况要考虑内存对齐？</strong></p>
<p>在不同平台之间（比如windows和linux），不同模块之间（dll与exe）传递二进制流（如结构体），必须要定义相同的对齐方式。</p>
<p>序列化与反序列化的操作时，也必须要定义相同的对齐方式。</p>
<p>OK.</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qw5lxyq.html">php token的生成</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mkrd0q.html">Can&rsquo;t Activate Reporting Services Service in SharePoint</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdrw608.html">基于TCPCopy的Dubbo服务引流工具-DubboCopy</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlxdm6q.html">java 28 - 4  JDK5的新特性 之  枚举的概述和自定义枚举类</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96ggry8.html">git命令笔记2</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2vexw8.html">第三次个人作业&mdash;&mdash;软件产品评测&lpar;K米Android端&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zlyk29.html">原 Linux搭建SVN 服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z14llx9.html">Struts2 本是非单例的，与Spring集成就默认为单例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn17wvg8.html">svn add后的数据如何取消-svn revert？？--zz</a>
		</li>
						<li><a href="https://www.batexi.com/a/950gldm8.html">列表类型转换&lpar;ConvertList&amp;lt&semi;TSource&comma; TResult&amp;gt&semi;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p4vj38.html">使用MyBatis时接收值和返回值选择Map类型或者实体类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlllm1eq.html">Executors创建的4种线程池的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv5vek8.html">使用参数innodb&lowbar;file&lowbar;per&lowbar;table支持MySQL InnoDB表数据共享空间自动收缩</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv562k8.html">PowerDesigner逆向生成MYSQL数据库表结构总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1dzpl9.html">import&lowbar;module 导入变量的包</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmzj3g9.html">2013-2014 ACM-ICPC&comma; NEERC&comma; Southern Subregional Contest Problem C&period; Equivalent Cards 计算几何</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rngdg7q.html">JVM进程cpu飙高分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppdded9.html">&period;net加载失败的程序集重新加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pdglg8.html">20145321《网络对抗技术》逆向与Bof基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn0zomq.html">&period;split&lpar;&amp;quot&semi;&comma;&amp;quot&semi;&comma; -1&rpar;&semi;和&period;split&lpar;&amp;quot&semi;&comma;&amp;quot&semi;&rpar;的区别</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdej1209.html">在SQL Server 2012中新建用户</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdn2er8.html">&lbrack;原创&rsqb;flexslider 中文文档 使用教程 参数手册</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydvzrjq.html">JAVA类与对象（四）----成员变量与局部变量 、成员方法、构造方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdej7gx9.html">P1231&colon; &lbrack;Usaco2008 Nov&rsqb;mixup2 混乱的奶牛</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdej7lv9.html">C&plus;&plus; 学习笔记（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdnene8.html">java无符号移位&lpar;&amp;gt&semi;&amp;gt&semi;&amp;gt&semi;&rpar;和有符号移位&lpar;&amp;gt&semi;&amp;gt&semi;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x34368.html">java 参数化类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1oy639.html">linux下的clock skew detected</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o3xxn9.html">《梦断代码》读书笔记第0篇&mdash;&mdash;&OpenCurlyDoubleQuote;软件时间&rdquo;、&OpenCurlyDoubleQuote;死定了&rdquo;、&OpenCurlyDoubleQuote;Agenda之魂&OpenCurlyDoubleQuote;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdej61x9.html">Eclipse问题解决集</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
